///////////////////////////////////////////////////////////////////////////////
// filename:    wMath.uc
// revision:    100
// authors:     Michiel 'El Muerte' Hendriks <elmuerte@drunksnipers.com>
//              Michaeel <mailto:mychaeel@beyondunreal.com>
///////////////////////////////////////////////////////////////////////////////

class wMath extends Object;

// TODO: check floats
static final function bool IsNumeric(coerce string Param, optional bool bPositiveOnly, optional bool bNoFloat)
{
  local int p;

  p=0;
  while (Mid(Param, p, 1) == " ") p++;
  if (!bPositiveOnly) if (Mid(Param, p, 1) == "-") p++;
  while (Mid(Param, p, 1) >= "0" && Mid(Param, p, 1) <= "9") p++;
  while (Mid(Param, p, 1) == " ") p++;
  if (Mid(Param, p) != "") return false;
  return true;
}

static final function bool IsInt(coerce string Param, optional bool bPositiveOnly)
{
  return IsNumeric(param, bPositiveOnly, true);
}

static final function bool IsFloat(coerce string Param, optional bool bPositiveOnly)
{
  return IsNumeric(param, bPositiveOnly, false);
}

/****************************************************************************
         CRC32 by Michaeel - http://wiki.beyondunreal.com/wiki/CRC32
  ****************************************************************************/
/* !! NEEDS WORK !!

// CRC32Init
// Initializes CrcTable and prepares it for use with Crc.
static final function CRC32Init() 
{
  const CrcPolynomial = 0xedb88320;
  local int CrcValue;
  local int IndexBit;
  local int IndexEntry;
  
  for (IndexEntry = 0; IndexEntry < 256; IndexEntry++) 
  {
    CrcValue = IndexEntry;
    for (IndexBit = 8; IndexBit > 0; IndexBit--)
      if ((CrcValue & 1) != 0)
        CrcValue = (CrcValue >>> 1) ^ CrcPolynomial;
      else
        CrcValue = CrcValue >>> 1;  
    CrcTable[IndexEntry] = CrcValue;
  }
}

// CRC32
// Calculates and returns a checksum of the given string. Call CrcInit before.
static final function int CRC32(coerce string Text) 
{

  local int CrcValue;
  local int IndexChar;
  CrcValue = 0xffffffff;
 
  for (IndexChar = 0; IndexChar < Len(Text); IndexChar++)
    CrcValue = (CrcValue >>> 8) ^ CrcTable[Asc(Mid(Text, IndexChar, 1)) ^ (CrcValue & 0xff)];
  return CrcValue;
}
*/